﻿<!--File Name: EditMap.cshtml-->
<!--File Description: Creates the view for displaying the page that allows the administrator to
    make changes to the smartMap json files.-->
<!DOCTYPE html>
<html>
<head>
    <script>
        var height = @ViewBag.map.height;
		var width = @ViewBag.map.width;
		var mapName = "@ViewBag.mapName";
        var xref = @Html.Raw(Json.Encode(ViewBag.xrefBoothCompany));
        var smartMap = @Html.Raw(Json.Encode(ViewBag.map));
    </script>
    <script src="~/Scripts/EditMap.js" language="javascript" type="text/javascript">
    </script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
</head>
<body>



    @*<div class="row page-header"><h2 class="center" id="header">@ViewBag.map.name</h2></div>*@
    <div class="white-background" style="padding: 15px">
        <br />
        <a href="~/Admin/SelectedMap?mapConfigIndex=@ViewBag.index" class="btn btn-default" style="margin-top: 5px;">Back to Admin Map Page</a>
        <hr />

        <!--Form for changing dimensions of table-->
        <form class="center" action="EditMap" method="get">
            @if (ViewBag.filename != "")
            {
                <input type="text" name="fileName" id="fileName" style="border:none !important; text-align:center;" value="@ViewBag.filename">
                <br />
                <label for="width">Width:</label>
                <input type="text" name="width" id="width" style="border:none !important; width: 30px;" value="@ViewBag.map.width" readonly>
                <label for="height">Height:</label>
                <input type="text" name="height" id="height" style="border:none !important; width: 30px;" value="@ViewBag.map.height" readonly>
                <br /><br />
                <p>Use the selections in bottom bar to change your map. The top selections are the actions and the bottom selections are the features you can specify for the selected action. <br />Then click cells on the map to change the selected cell to your configurations. <br />The <strong>Save Changes</strong> button saves all changes you made to the map.<br />The <strong>Revert Changes</strong> button reverts all your changes to your last save. *Once you save, you can't revert back.<br />The <strong>Download Map</strong> downloads the current map you have as a png image, even if you have not saved the changes yet. *This will not save the current changes.</p>
            }
            else
            {
                <label for="fileName">File Name</label>
                <input type="text" name="fileName" id="fileName" value="@ViewBag.filename" required>
                <br />
                <label for="width">Width:</label>
                <input type="text" name="width" id="width" value="@ViewBag.map.width" required>
                <label for="height">Height:</label>
                <input type="text" name="height" id="height" value="@ViewBag.map.height" required>
                <input value="Create Map" type="submit" style="margin-top: 5px;">
                <br />
                <br />
                <p>Enter a name for your new file and the map's dimensions. Please do not put any spaces in the file name.</p>
            }
            <input type="hidden" name="change" id="change" value="dimensions">
        </form>

        <!--Display editing map-->
        <div>
            <form class="center" action="EditMap" method="post">
                <button onclick="location = 'EditMap?fileName=' + fileName.value" style="margin-top: 5px; margin-bottom: 20px;">Revert Changes</button>
                <input type="hidden" name="fileName" id="fileName" value="@ViewBag.filename">
            </form>
            <form class="center" action="EditMap" enctype="multipart/form-data" method="post">
                <input value="Save Changes" type="submit" style="margin-top: 5px; margin-bottom: 20px;">
                <input type="hidden" name="fileName" id="fileName" value="@ViewBag.filename">
                <input type="hidden" name="change" value="saveAll" />
                @*hidden table to store values*@
                <table id="values" hidden>
                    @for (int i = 0; i < ViewBag.map.height; i++)
                    {
                        <tr>
                            @for (int j = 0; j < ViewBag.map.width; j++)
                            {
                                <td>
                                    <input id="topBorder@(i):@(j)" name="topBorder@(i):@(j)" value=@Convert.ToString(ViewBag.map.cellContents[i][j].border[0]) />
                                    <input id="rightBorder@(i):@(j)" name="rightBorder@(i):@(j)" value=@Convert.ToString(ViewBag.map.cellContents[i][j].border[1]) />
                                    <input id="bottomBorder@(i):@(j)" name="bottomBorder@(i):@(j)" value=@Convert.ToString(ViewBag.map.cellContents[i][j].border[2]) />
                                    <input id="leftBorder@(i):@(j)" name="leftBorder@(i):@(j)" value=@Convert.ToString(ViewBag.map.cellContents[i][j].border[3]) />
                                    <input id="cellColor@(i):@(j)" name="cellColor@(i):@(j)" value="@ViewBag.map.cellContents[i][j].cellColor" />
                                    <input id="textColor@(i):@(j)" name="textColor@(i):@(j)" value="@ViewBag.map.cellContents[i][j].textColor" />
                                    <input id="text@(i):@(j)" name="text@(i):@(j)" value="@ViewBag.map.cellContents[i][j].text" />
                                    <input id="isBooth@(i):@(j)" name="isBooth@(i):@(j)" value=@Convert.ToString(ViewBag.map.cellContents[i][j].isBooth) />
                                </td>
                            }
                        </tr>
                    }
                </table>
                <input type="hidden" name="mapHeight" id="mapHeight" value=@ViewBag.map.height>
                <input type="hidden" name="mapWidth" id="mapWidth" value=@ViewBag.map.width>
            </form>
            <div class="center">
                <button onclick="downloadImage()" style="margin-bottom: 10px">Download Map</button>
            </div>
        </div>
        <br />

        <canvas id="smartEditor">
            Your browser does not support HTML5 canvas. Update your browser to use this feature.
        </canvas>
    </div>


    <nav class="navbar-fixed-bottom editmap-bottom-bar" style="padding-top: 10px">
        <div style="margin-top: 5px; margin-left: 10px">
            <label><input type="checkbox" id="cellClick" name="cellClick" onclick="change('cell')" checked />Change Cell</label> <br />
            <label><input type="checkbox" id="textClick" name="textClick" onclick="change('text')" />Change Text</label> <br />
            <label><input type="checkbox" id="mapClick" name="mapClick" onclick="change('map')" />Change Map Format</label>
        </div>
        <div class="center" style="margin-bottom: 5px; margin-right: 10px; position: absolute; right: 0; bottom: 0">
            @*Cell editing*@
            <label id="cellLabel">Cell Color: <input type="color" id="color" name="color" value="#ffffff" /></label><br />
            <label id="label-top"><input type="checkbox" id="border-top" name="border-top" checked style="margin-right: 3px" />Top Border</label>
            <label id="label-right"><input type="checkbox" id="border-right" name="border-right" checked style="margin-right: 3px" />Right Border</label><br />
            <label id="label-bottom"><input type="checkbox" id="border-bottom" name="border-bottom" checked style="margin-right: 3px" />Bottom Border</label>
            <label id="label-left"><input type="checkbox" id="border-left" name="border-left" checked style="margin-right: 3px" />Left Border</label>
        </div>
        <div class="center" style="margin-bottom: 5px; margin-right: 10px; position: absolute; right: 0; bottom: 0">
            @*Text editing*@
            <label id="textLabel" hidden>Text Color: <input type="color" id="textColor" name="textColor" value="#000000" /><br /></label><br />
            <label id="label-booth" hidden><input type="checkbox" id="isBooth" name="isBooth" style="margin-right: 3px" />Is Booth Cell</label>
        </div>
        <div class="center" style="margin-bottom: 5px; margin-right: 10px; position: absolute; right: 0; bottom: 0">
            @*Map format editing*@
            <button id="addRow" name="addRow" onclick="addNew('row')" hidden>Add New Row</button>
            <button id="addCol" name="addCol" onclick="addNew('col')" hidden>Add New Column</button><br />
            <label id="insertRowLabel" hidden><input type="checkbox" id="insertRow" name="insertRow" onclick="changeFormat('ir')" checked style="margin-right: 3px" />Insert Row</label>
            <label id="deleteRowLabel" hidden><input type="checkbox" id="deleteRow" name="deleteRow" onclick="changeFormat('dr')" style="margin-right: 3px" />Delete Row<br /></label><br />
            <label id="insertColLabel" hidden><input type="checkbox" id="insertCol" name="insertCol" onclick="changeFormat('ic')" style="margin-right: 3px" />Insert Column</label>
            <label id="deleteColLabel" hidden><input type="checkbox" id="deleteCol" name="deleteCol" onclick="changeFormat('dc')" style="margin-right: 3px" />Delete Column</label>
        </div>
    </nav>

</body>
</html>